c           testing cgetcm; getting cm frame of two particles
c     include 'cgetlf.f'
c     include 'clorez.f'
c     include 'cgeqm.f'
c --------------------------------------
c
c     implicit none
c     include '../Zptcl.h'
c
c     record /fmom/ gc, p1, p2, gci
c     record /ptcl/ pp1, pp2, t1, t2
c     integer icon
c     p1.x=0.
c     p1.y=0.
c     p1.z=1.e3
c     p2.x=0.
c     p2.y=0.
c     p2.z=0.
c
c     pp1.mass=.938
c     pp2.mass=.938
c     p1.e=sqrt(p1.x**2 + p1.y**2+p1.z**2 + pp1.mass**2)
c     p2.e=sqrt(p2.x**2 + p2.y**2+p2.z**2 + pp2.mass**2)
c     pp1.fm = p1
c     pp2.fm = p2
c     call cgetcm(pp1, pp2, gc, icon)
c     write(*, *) gc.p
c     t1 = pp1
c     t2 = pp2
c     gci.x = - gc.x
c     gci.y = - gc.y
c     gci.z = - gc.z
c     gci.t = gc.t
c     call clorez(gci, pp1,  t1)
c     call clorez(gci, pp2,  t2)
c     write(*, *)  t1.fm.p, t2.fm.p
c     call cgetcm(t1, t2, gc, icon)
c     write(*, *) gc.p
c     end
      subroutine cgetcm(p1, p2,  gc, icon)
c         get Lorentz factor of the Center of Momentum
c         system of arbitrary two particles.
c      p1: structure /ptcl/. Input.  particle 1
c      p2: structure /ptcl/. Input.  particle 2
c      gc: structure /fmom/. Output. (g*beta, g) of the
c          cm frame. 
c    icon: integer. output.  0 -> ok.  1 -> no cms definable.
c              if icon = 1, gc is undef.
         implicit none
c----         include '../Zptcl.h'
#include  "Zptcl.h"
         record /ptcl/ p1, p2
         record /fmom/ gc
c
         record  /fmom/ q

         integer icon
c
         call cgeqm(p1, p2, q, icon)         
         if(icon .eq. 0) then
c            get Lorentz factor of q
             call cgetlf(q, gc)
         endif    
        end         

